// Copyright (c) 2012, Robert Escriva
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//     * Redistributions of source code must retain the above copyright notice,
//       this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of Replicant nor the names of its contributors may be
//       used to endorse or promote products derived from this software without
//       specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.

#ifndef replicant_special_objects_h_
#define replicant_special_objects_h_

#define IS_SPECIAL_OBJECT(X) ((X & 0xff00000000000000ULL) == 0x5f00000000000000ULL)

// Here's some Python to generate the numbers:
//
// >>> print '0x%sULL' % ''.join(['%02x' % ord(c) for c in '_clients'])
// 0x5f636c69656e7473ULL

// Special objects
#define OBJECT_CLI_REG 0x5f636c695f726567ULL /*_cli_reg*/
#define OBJECT_CLI_DIE 0x5f636c695f646965ULL /*_cli_die*/
#define OBJECT_OBJ_NEW 0x5f6f626a5f6e6577ULL /*_obj_new*/
#define OBJECT_OBJ_DEL 0x5f6f626a5f64656cULL /*_obj_del*/
#define OBJECT_OBJ_SNAPSHOT 0x5f6f626a5f736e61ULL /*_obj_sna*/
#define OBJECT_OBJ_RESTORE 0x5f6f626a5f726573ULL /*_obj_res*/

#endif // replicant_special_objects_h_
